VAR
  long clktics
  long samples
  long channel
  long params[5]
  long data[4000]

PUB start (cs,clock,io,rate)
    clktics:=3072
    if rate > 0  
       clktics:=2850/rate       'at 80Mhz clock this provides about 10Ksps
    params[1]:=cs           'Propeller pin 0 for chip select
    params[2]:=clock          'propeller pin 1 for clock
    params[3]:=io           'propeller pin 2 for io

    cognew(@tester,@params)
    {waitcnt(clkfreq/3 + cnt)
    params[0]:=1
    repeat until params[0]==0
    return  params[4]   }
    

PUB getadc(x,samp)  
    samples:=samp
    channel:=x
    params[0]:=1
    REPEAT until params[0]==0                                             
    RETURN params[4]
    
PUB report(which)  
    return data[which]
    
'PUB getclocks
  '  return params[4

DAT

tester             org 

                 mov fad,par
                 mov srate,par
                 sub srate,#12
                 rdlong hold,srate     '
                 mov t3, par
                 add t3,#4
                 rdlong cs_,t3            'create propeller pinmask for chip select pin
                 mov temp,one
                 shl temp,cs_
                 mov cs_,temp            'cs_ is now pinmask
                 add t3,#4
                 rdlong clk_,t3           'create pin mask for clk pin
                 mov temp,one
                 shl temp,clk_
                 mov clk_,temp
                 add t3,#4                 
                 rdlong io_,t3            'create pin mask for io
                 mov  temp,one
                 shl temp,io_
                 mov io_,temp            
                 muxnz dira,clk_             'make clk pin output
                 muxnz dira,cs_              'make chipselect pin output
                 add t3,#4                   'write location for total clocks for acquisition
                 MUXNZ OUTA,CS_
                                             'make chip select high

                                             

:wait           
                 rdlong t1,fad  wz              'params[0] not zero terminates wait state
        if_z     jmp #:wait
                 mov chanadd,fad
                 sub chanadd,#4
                 rdlong chan,chanadd       'read contents of chanadd into chan... gets channel value into chan
                 sub chanadd,#4
                 rdlong reps,chanadd
                 mov datemp,fad
                 add datemp,#20
                 wrlong zero,datemp
                 mov tic1,cnt
        
:loop1           muxnz outa,cs_                  'make chip select high... deactivates 1298

:sendcmd         muxnz dira,io_          'make io an output
                 muxz outa,io_           'make io low
                 muxz outa,cs_            'make chip select low to start
               
:sendbits                                     'send 4 control bits to ltc198
                 muxz outa,clk_                 'clock  low...
                 muxnz outa,io_                  '  bit1 out to 1298, set io_ high
                 muxnz outa,clk_               ' make  clock high... bit recieved by ltc1298
                 muxz outa,clk_                 'clock  low... 
                 muxnz outa,io_                  ' set bit 2 io_ high
                 muxnz outa,clk_               ' make  clock high... starts bit2 recieve by ltc1298
                 cmp chan,#1     wc
                 muxz outa,clk_                 'clock  low...
                 muxz outa,io_                  'set bit 3 low\     select ch0
        if_nc    muxnz outa,io_                 'set bit 3 high   select ch1
                 muxnz outa,clk_               ' make  clock high... starts bit3 recieve by ltc1298 
                 muxz outa,clk_                 'clock  low... 
                 muxnz outa,io_                  'set bit 4, set io_ high
                 muxnz outa,clk_               ' make  clock high... starts data receive from io by ltc1298
                 muxz outa,clk_                 ' make clock low
                 muxz dira,io_          'make io an input
                 mov temp,adcbits     'temp is repetitions in repeat loop, :getbits
                 mov val,zero         'val is adc value
                 mov time,cnt
                 add time,hold
                 
:getbits         muxnz outa,clk_         'sets clk line high, signalling ltc1298 to output converion
                 waitcnt time, hold
                 test io_,ina      wc      'c is one if io_ high
                 rcl val,#1                  'rotate previou value of val one bit left to make room for inbit resut
                 muxz outa,clk_         'set  clk low
                 waitcnt time, hold
                 djnz temp, #:getbits
                 
                 wrlong val,datemp
                 add datemp, #4
                 djnz reps, #:loop1
                 mov val,#0
                 wrlong zero,fad  'write zero value back to hub  params[0] -- tells calling routine that acquisition is done
                 muxnz dira,cs_
                 mov tic2,cnt
                 sub tic2,tic1
                 wrlong tic2,t3
                 jmp #:wait           'go back to wait
 
one long 1
zero long 0
adcbits long 13

hold res 1     'used for waitcnt         
chan   res 1
reps res 1
chanadd res 1
val res 1
temp res 1
datemp res 1
cmd res 1
t1 res   1
t3 res 1
cs_ res 1
clk_ res 1
io_ res  1
time res 1               
fad res 1
tic1 res 1
tic2 res 1
srate res 1 